#########################################################
# Bandwidth useage v0.1
#########################################################
# HomePage: http://www.ofloo.net/
# Contact: support[at]ofloo.net
# Tested on debian linux os and windows nt4/nt2k/xp
# Note: make sur that on linux systems the dev proc is 
# readable some shell providers disable this option.
#########################################################

#########################
# Change trigger
#########################
set bw(trigger) "!bw"

#########################
# Required linux only
# u know eth0 .. type
# be sur that this 
# device exists or it
# will return nothing
#########################
set bw(adapter) "ppp0"

#########################
# Required linux only
#########################
set bw(procdev) "/proc/net/dev"

#########################
# enable disable bold
#########################
set bw(bold) 1

#########################
# 0 privmsg chan, 
# 1 privmsg nick, 
# 2 notice nick
#########################
set bw(type) 0

#########################
# do not touch below
#########################

#########################
# version
#########################
set bw(version) 0.1

#########################
# Bind
#########################
bind pub - $bw(trigger) bw:pub

#########################
# determene os type
#########################
switch  -- [string tolower $tcl_platform(platform)] {
  "windows" {
    set bw(switch) 0
  }
  "unix" {
    set bw(switch) 1
    if {![file exists $bw(procdev)]} {
      putlog "Config error bw script, $bw(procdev) does not exist."
      return 0
    }
  }
}

#########################
# enable disable bold
#########################
switch  -- $bw(bold) {
  "0" {
    set bw(b) ""
  }
  "1" {
    set bw(b) "\002"
  }
}

#########################
# msg type switch 
#########################
switch  -- $bw(type) {
  "0" {
    set bw(msgtype) "PRIVMSG %CHAN%"
  }
  "1" {
    set bw(msgtype) "PRIVMSG %NICK%"
  }
  "2" {
    set bw(msgtype) "NOTICE %NICK%"
  }
}

#########################
# Main proc
#########################
proc bw:pub {nick host hand chan arg} {
  global bw
  if {$bw(switch)} {
    set rf [open $bw(procdev) r]
    set rd [read $rf]
    close $rf
    foreach x [split $rd \n] { 
      if {[string match -nocase $bw(adapter) [lindex [split [lindex $x 0] \x3A] 0]]} { 
        set inc_s [lindex [split [lindex $x 0] \x3A] 1] 
        set out_s [lindex $x 8] 
      } 
    }
    after 500
    set rf [open $bw(procdev) r]
    set rd [read $rf]
    close $rf
    foreach x [split $rd \n] { 
      if {[string match -nocase $bw(adapter) [lindex [split [lindex $x 0] \x3A] 0]]} { 
        set inc_e [lindex [split [lindex $x 0] \x3A] 1] 
        set out_e [lindex $x 8] 
      } 
    }
    putserv "[string map [list %CHAN% $chan %NICK% $nick] $bw(msgtype)] :\($bw(b)Traffic$bw(b)\): Incoming: \($bw(b)[format %.2f [expr ($inc_e-$inc_s)/512.0]]$bw(b)\) kb/s Outgoing: \($bw(b)[format %.2f [expr ($out_e-$out_s)/512.0]]$bw(b)\) kb/s"
  } else {
    foreach x [split [exec netstat.exe -e] \n] {
      if {[string match -nocase byte* $x]} {
        set inc_s "[lindex $x 1]"
        set out_s "[lindex $x 2]"
      }
    }
    after 500
    foreach x [split [exec netstat.exe -e] \n] {
      if {[string match -nocase byte* $x]} {
        set inc_e "[lindex $x 1]"
        set out_e "[lindex $x 2]"
      }
    }
    putserv "[string map [list %CHAN% $chan %NICK% $nick] $bw(msgtype)] :\($bw(b)Traffic$bw(b)\): Incoming: \($bw(b)[format %.2f [expr ($inc_e-$inc_s)/512.0]]$bw(b)\) kb/s Outgoing: \($bw(b)[format %.2f [expr ($out_e-$out_s)/512.0]]$bw(b)\) kb/s"
  }
}

#########################################################
putlog "Bandwidth usage version \002$bw(version)\002 by \002Ofloo\002."